import { OdooModel } from "../decorators/model";
import { OdooField } from "../decorators/field";
import { FieldTypes } from "../types/field";

@OdooModel("account.tax")
export class AccountTax {

    @OdooField(FieldTypes.FLOAT)
    amount: number;

    @OdooField(FieldTypes.SELECTION)
    applicable_type: string;

    @OdooField(FieldTypes.MANY2ONE)
    base_code_id: any;

    @OdooField(FieldTypes.FLOAT)
    base_sign: number;

    @OdooField(FieldTypes.BOOLEAN)
    child_depend: boolean;

    @OdooField(FieldTypes.ONE2MANY)
    child_ids: any;

    @OdooField(FieldTypes.MANY2ONE)
    company_id: any;

    @OdooField(FieldTypes.CHAR)
    display_name: string;

    @OdooField(FieldTypes.CHAR)
    name: string;

    @OdooField(FieldTypes.BOOLEAN)
    price_include: boolean;

    @OdooField(FieldTypes.MANY2ONE)
    tax_code_id: any;

    @OdooField(FieldTypes.FLOAT)
    tax_sign: number;

    @OdooField(FieldTypes.SELECTION)
    type: string;

    @OdooField(FieldTypes.SELECTION)
    type_tax_use: string;
}