import { OdooModel } from "../decorators/model";
import { OdooField } from "../decorators/field";
import { FieldTypes } from "../types/field";

import { Base } from "./base";

@OdooModel("res.partner", [["active", "=", true]])
export class Partner extends Base {

    @OdooField({ type: FieldTypes.ONE2MANY, related: Partner })
    child_ids: any;

    @OdooField(FieldTypes.CHAR)
    city: string;

    @OdooField(FieldTypes.CHAR)
    contact_address: string;

    @OdooField(FieldTypes.BOOLEAN)
    customer: boolean;

    @OdooField(FieldTypes.DATE)
    date_localization: string;

    @OdooField(FieldTypes.CHAR)
    display_name: string;

    @OdooField(FieldTypes.CHAR)
    email: string;

    @OdooField(FieldTypes.BOOLEAN)
    employee: boolean;

    @OdooField(FieldTypes.CHAR)
    fax: string;

    @OdooField(FieldTypes.CHAR)
    image_medium: string;

    @OdooField(FieldTypes.BOOLEAN)
    is_company: boolean;

    @OdooField(FieldTypes.CHAR)
    mobile: string;

    @OdooField(FieldTypes.CHAR)
    name: string;

    @OdooField(FieldTypes.FLOAT)
    partner_latitude: number;

    @OdooField(FieldTypes.FLOAT)
    partner_longitude: number;

    @OdooField(FieldTypes.CHAR)
    phone: string;

    @OdooField(FieldTypes.CHAR)
    street: string;
}