import { OdooModel } from "../decorators/model";
import { OdooField } from "../decorators/field";
import { FieldTypes } from "../types/field";

@OdooModel("sale.order")
export class SaleOrder {

    @OdooField(FieldTypes.FLOAT)
    amount_tax: number;

    @OdooField(FieldTypes.FLOAT)
    amount_total: number;

    @OdooField(FieldTypes.FLOAT)
    amount_untaxed: number;

    @OdooField(FieldTypes.INTEGER)
    cart_quantity: number;

    @OdooField(FieldTypes.MANY2MANY)
    categ_ids: any;

    @OdooField(FieldTypes.MANY2ONE)
    company_id: any;

    @OdooField(FieldTypes.DATETIME)
    create_date: string;

    @OdooField(FieldTypes.MANY2ONE)
    currency_id: any;

    @OdooField(FieldTypes.DATE)
    date_confirm: string;

    @OdooField(FieldTypes.DATETIME)
    date_order: string;

    @OdooField(FieldTypes.CHAR)
    display_name: string;

    @OdooField(FieldTypes.BOOLEAN)
    invoiced: boolean;

    @OdooField(FieldTypes.CHAR)
    name: string;

    @OdooField(FieldTypes.ONE2MANY)
    order_line: any;

    @OdooField(FieldTypes.MANY2ONE)
    partner_id: any;

    @OdooField(FieldTypes.SELECTION)
    state: string;

    @OdooField(FieldTypes.MANY2ONE)
    user_id: any;

    @OdooField(FieldTypes.MANY2ONE)
    warehouse_id: any;
}