import { OdooModel } from "../decorators/model";
import { OdooField } from "../decorators/field";
import { FieldTypes } from "../types/field";

@OdooModel("stock.quant", [["qty", ">", 0]])
export class StockQuant {

    @OdooField(FieldTypes.MANY2ONE)
    company_id: any;

    @OdooField(FieldTypes.FLOAT)
    cost: number;

    @OdooField(FieldTypes.CHAR)
    display_name: string;

    @OdooField(FieldTypes.FLOAT)
    inventory_value: number;

    @OdooField(FieldTypes.MANY2ONE)
    location_id: any;

    @OdooField(FieldTypes.CHAR)
    name: string;

    @OdooField(FieldTypes.MANY2ONE)
    product_id: any;

    @OdooField(FieldTypes.FLOAT)
    qty: number;

    @OdooField(FieldTypes.MANY2ONE)
    propagated_from_id: any;
}