import { AccountTax } from "../models/account.tax";
import { AccountTaxCode } from "../models/account.tax.code";
import { CaseCategory } from "../models/crm.case.categ";
import { CaseStage } from "../models/crm.case.stage";
import { Currency } from "../models/res.currency";
import { Lead } from "../models/crm.lead";
import { Partner } from "../models/res.partner";
import { Phonecall } from "../models/crm.phonecall";
import { PriceList } from "../models/product.pricelist";
import { ProductTemplate } from "../models/product.template";
import { ProductProduct } from "../models/product.product";
import { ProductAttributeLine } from "../models/product.attribute.line";
import { ProductAttributeValue } from "../models/product.attribute.value";
import { ProductAttributePrice } from "../models/product.attribute.price";
import { ProductAttribute } from "../models/product.attribute";
import { SaleOrder } from "../models/sale.order";
import { SaleOrderLine } from "../models/sale.order.line";
import { StockWarehouse } from "../models/stock.warehouse";
import { StockQuant } from "../models/stock.quant";
import { StockLocation } from "../models/stock.location";

/**
 *
 * ██╗███╗   ███╗██████╗  ██████╗ ██████╗ ████████╗███╗   ███╗ ██████╗ ██████╗ ███████╗██╗     ███████╗
 * ██║████╗ ████║██╔══██╗██╔═══██╗██╔══██╗╚══██╔══╝████╗ ████║██╔═══██╗██╔══██╗██╔════╝██║     ██╔════╝
 * ██║██╔████╔██║██████╔╝██║   ██║██████╔╝   ██║   ██╔████╔██║██║   ██║██║  ██║█████╗  ██║     ███████╗
 * ██║██║╚██╔╝██║██╔═══╝ ██║   ██║██╔══██╗   ██║   ██║╚██╔╝██║██║   ██║██║  ██║██╔══╝  ██║     ╚════██║
 * ██║██║ ╚═╝ ██║██║     ╚██████╔╝██║  ██║   ██║   ██║ ╚═╝ ██║╚██████╔╝██████╔╝███████╗███████╗███████║
 * ╚═╝╚═╝     ╚═╝╚═╝      ╚═════╝ ╚═╝  ╚═╝   ╚═╝   ╚═╝     ╚═╝ ╚═════╝ ╚═════╝ ╚══════╝╚══════╝╚══════╝
 *
 * Función que se encarga de cargar los modelos proporcionados al motor de reflectividad de clases
 * y por consiguiente extrae sus propiedades para luego definirlos en una registro temporal de metadatos
 */
export function importModels(): void {
    const models: Function[] = [];

    models.push(
        AccountTax,
        AccountTaxCode,
        CaseCategory,
        CaseStage,
        Currency,
        Lead,
        Partner,
        Phonecall,
        PriceList,
        ProductTemplate,
        ProductProduct,
        ProductAttributeLine,
        ProductAttributeValue,
        ProductAttributePrice,
        ProductAttribute,
        SaleOrder,
        SaleOrderLine,
        StockWarehouse,
        StockQuant,
        StockLocation
    );
}