import { Pipe, PipeTransform } from '@angular/core';

/**
 *
 * ███╗   ███╗███████╗███╗   ██╗██╗   ██╗██████╗ ██╗██████╗ ███████╗
 * ████╗ ████║██╔════╝████╗  ██║██║   ██║██╔══██╗██║██╔══██╗██╔════╝
 * ██╔████╔██║█████╗  ██╔██╗ ██║██║   ██║██████╔╝██║██████╔╝█████╗  
 * ██║╚██╔╝██║██╔══╝  ██║╚██╗██║██║   ██║██╔═══╝ ██║██╔═══╝ ██╔══╝  
 * ██║ ╚═╝ ██║███████╗██║ ╚████║╚██████╔╝██║     ██║██║     ███████╗
 * ╚═╝     ╚═╝╚══════╝╚═╝  ╚═══╝ ╚═════╝ ╚═╝     ╚═╝╚═╝     ╚══════╝
 *
 * Pipe que filtra solamente los menues que serán visibles
 *
 */
@Pipe({
  	name: 'menu'
})
export class MenuPipe implements PipeTransform {
  
    transform(menus: Array<any>, visible: boolean) {
        return menus.filter(item => { 
            return item.visible == visible;
        });
    }
}
